> ## Documentation Index
> Fetch the complete documentation index at: https://docs.lightdash.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Rotate service account

> Rotate an expiring service account's token. Requires organization
administration permission. The old token is immediately revoked and the
replacement is returned once. Rotation is limited to once per hour.



## OpenAPI

````yaml https://raw.githubusercontent.com/lightdash/lightdash/refs/heads/main/packages/backend/src/generated/swagger.json patch /api/v1/service-accounts/{tokenUuid}/rotate
openapi: 3.0.0
info:
  title: Lightdash API
  version: 3.25.0
  description: >
    Open API documentation for all public Lightdash API endpoints. #
    Authentication Authenticate using the Authorization header with either
    'ApiKey <personal-access-token>' or 'Bearer <service-account-token>'. Create
    a Personal Access Token by following this guide:
    https://docs.lightdash.com/references/personal_tokens Self-hosted
    provisioning can use the admin token configured with
    LD_SETUP_SERVICE_ACCOUNT_TOKEN to create scoped service accounts through the
    Service Accounts API.
  license:
    name: MIT
  contact:
    name: Lightdash Support
    email: support@lightdash.com
    url: https://docs.lightdash.com/help-and-contact/contact/contact_info/
servers:
  - url: /
security: []
tags:
  - name: My Account
    description: These routes allow users to manage their own user account.
  - name: Organizations
    description: >-
      Each user is a member of a single organization. These routes allow users
      to manage their organization. Most actions are only available to admin
      users.
  - name: Projects
    description: >-
      Projects belong to a single organization. These routes allow users to
      manage their projects, browse content, and execute queries. Users inside
      an organization might have access to a project from an organization-level
      role or they might be granted access to a project directly.
  - name: Spaces
    description: >-
      Spaces allow you to organize charts and dashboards within a project. They
      also allow granular access to content by allowing you to create private
      spaces, which are only accessible to the creator and admins.
  - name: Roles & Permissions
    description: >-
      These routes allow users to manage roles and permissions for their
      organization.
    externalDocs:
      url: https://docs.lightdash.com/references/roles
  - name: Service Accounts
    description: >-
      Create and manage machine credentials for your organization. Requires
      organization administration permission. Use predefined organization
      scopes, a custom organization role, or grants to selected projects.
      Credentials cannot grant more access than the caller holds.
  - name: Query
    description: >-
      These routes allow users to execute and manage queries against their data
      warehouse. This includes metric queries, SQL queries, and retrieving query
      results.
paths:
  /api/v1/service-accounts/{tokenUuid}/rotate:
    patch:
      tags:
        - Service Accounts
      summary: Rotate service account
      description: |-
        Rotate an expiring service account's token. Requires organization
        administration permission. The old token is immediately revoked and the
        replacement is returned once. Rotation is limited to once per hour.
      operationId: RotateServiceAccount
      parameters:
        - in: path
          name: tokenUuid
          required: true
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              properties:
                expiresAt:
                  type: string
                  format: date-time
              required:
                - expiresAt
              type: object
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                properties:
                  results:
                    $ref: '#/components/schemas/ServiceAccountWithToken'
                  status:
                    type: string
                    enum:
                      - ok
                    nullable: false
                required:
                  - results
                  - status
                type: object
        default:
          description: Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorPayload'
      security: []
components:
  schemas:
    ServiceAccountWithToken:
      allOf:
        - $ref: '#/components/schemas/ServiceAccount'
        - properties:
            token:
              type: string
              description: >-
                Bearer token returned only when creating or rotating the service
                account.
          required:
            - token
          type: object
    ApiErrorPayload:
      properties:
        error:
          properties:
            data:
              $ref: '#/components/schemas/AnyType'
              description: Optional data containing details of the error
            message:
              type: string
              description: A friendly message summarising the error
            name:
              type: string
              description: Unique name for the type of error
            statusCode:
              type: number
              format: integer
              description: HTTP status code
          required:
            - name
            - statusCode
          type: object
        status:
          type: string
          enum:
            - error
          nullable: false
      required:
        - error
        - status
      type: object
      description: |-
        The Error object is returned from the api any time there is an error.
        The message contains
    ServiceAccount:
      properties:
        roleUuid:
          type: string
          nullable: true
        userUuid:
          type: string
        scopes:
          items:
            $ref: '#/components/schemas/ServiceAccountScope'
          type: array
        rotatedAt:
          type: string
          format: date-time
          nullable: true
        lastUsedAt:
          type: string
          format: date-time
          nullable: true
        description:
          type: string
        expiresAt:
          type: string
          format: date-time
          nullable: true
          description: Expiration timestamp, or null for a token that does not expire.
        createdAt:
          type: string
          format: date-time
        organizationUuid:
          type: string
        createdBy:
          properties:
            lastName:
              type: string
            firstName:
              type: string
            userUuid:
              type: string
          required:
            - lastName
            - firstName
            - userUuid
          type: object
          nullable: true
        createdByUserUuid:
          type: string
          nullable: true
        uuid:
          type: string
      required:
        - roleUuid
        - userUuid
        - scopes
        - rotatedAt
        - lastUsedAt
        - description
        - expiresAt
        - createdAt
        - organizationUuid
        - createdBy
        - createdByUserUuid
        - uuid
      type: object
    AnyType:
      description: |-
        This AnyType is an alias for any
        The goal is to make it easier to identify any type in the codebase
        without having to eslint-disable all the time
        These are only used on legacy `any` types, don't use it for new types.
        This is added on a separate file to avoid circular dependencies.
    ServiceAccountScope:
      enum:
        - scim:manage
        - org:admin
        - org:edit
        - org:read
        - system:member
        - system:admin
        - system:developer
        - system:editor
        - system:interactive_viewer
        - system:viewer
      type: string

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.